# Load packages
library(reshape2)
library(spaa)
library(psych)

################goose absence#########################
# load data
testdata<-read.csv("plant.assocaition.goose.absence.csv",header=F,row.names=1)
colname<-testdata[1:2,]
testdata<-testdata[-c(1:2),]
testdata<-as.data.frame(apply(testdata,2,FUN=as.numeric))
colnames(testdata)<-colname[1,]
# filter the data, such as selecting only species that appear in at least several samples.
tmp<-testdata
tmp[tmp>1]-1 
tmp
f1<-which(colSums(tmp)>=0)
testdata<-testdata[,f1]
# Calculate the overall the overall interspecific association 
result1<-sp.assoc(testdata)
result1
# Calculate interspecific association
result.association<-sp.pair(testdata)

result<-corr.test(testdata,method="spearman",adjust="fdr",alpha=0.05)
cor.r<-data.frame(result$r)
cor.p<-data.frame(result$p)


# Convert the data to long format for filtering. Node and link data are needed to draw the network diagram later. In this step, the format can be completed.
# Add a new ID column here to facilitate data conversion
cor.r$node<-rownames(cor.r)
cor.p$node<-rownames(cor.p)
# Next, perform data conversion to convert wide data into long data.
r<-melt(cor.r,id.vars="node",value.name="r")
p<-melt(cor.p,id.vars="node",value.name="p")

result.data<-data.frame(r,p=p$p)
colnames(result.data)<-c("node1","node2","r","p")

## Next, filter the data
#Remove the data of node1=node2
result.data<-subset(result.data,result.data$node1!=result.data$node2)
# Set filter threshold
p.cutoff<-0.001
r.cutoff<-0.6
# Filter the data below
result.data<-result.data[which(abs(result.data$r)>=r.cutoff&result.data$p<=p.cutoff),]
write.csv(file="goose_absence.csv",result.data[,1:3])


################goose presence#########################
# load data
testdata<-read.csv("plant.assocaition.goose.presence.csv",header=F,row.names=1)
colname<-testdata[1:2,]
testdata<-testdata[-c(1:2),]
testdata<-as.data.frame(apply(testdata,2,FUN=as.numeric))
colnames(testdata)<-colname[1,]
# filter the data, such as selecting only species that appear in at least several samples.
tmp<-testdata
tmp[tmp>1]-1 
tmp
f1<-which(colSums(tmp)>=0)
testdata<-testdata[,f1]
# Calculate the overall the overall interspecific association 
result1<-sp.assoc(testdata)
result1
# Calculate interspecific association
result.association<-sp.pair(testdata)

result<-corr.test(testdata,method="spearman",adjust="fdr",alpha=0.05)
cor.r<-data.frame(result$r)
cor.p<-data.frame(result$p)


# Convert the data to long format for filtering. Node and link data are needed to draw the network diagram later. In this step, the format can be completed.
# Add a new ID column here to facilitate data conversion
cor.r$node<-rownames(cor.r)
cor.p$node<-rownames(cor.p)
# Next, perform data conversion to convert wide data into long data.
r<-melt(cor.r,id.vars="node",value.name="r")
p<-melt(cor.p,id.vars="node",value.name="p")

result.data<-data.frame(r,p=p$p)
colnames(result.data)<-c("node1","node2","r","p")

## Next, filter the data
#Remove the data of node1=node2
result.data<-subset(result.data,result.data$node1!=result.data$node2)
# Set filter threshold
p.cutoff<-0.001
r.cutoff<-0.6
# Filter the data below
result.data<-result.data[which(abs(result.data$r)>=r.cutoff&result.data$p<=p.cutoff),]
write.csv(file="goose_presence.csv",result.data[,1:3])
